VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} frmColorSelect 
   Caption         =   "GDG Color Select"
   ClientHeight    =   1890
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   3255
   OleObjectBlob   =   "frmColorSelect.frx":0000
   ShowModal       =   0   'False
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "frmColorSelect"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Const cMACRONAME$ = "GDG Color Select"

Private Sub cmdCol_Click()
    Dim i%
    
    i = 1
    saveCol getColorClick, i
    setControlColor i, "cmdCol"

End Sub
Private Sub cmdCol2_Click()
    Dim i%, strName$
    i = 2: strName = "cmdCol2"
    
    saveCol getColorClick, i
    setControlColor i, strName
End Sub


Private Function getColorClick() As Color
    On Error Resume Next
    Set getColorClick = New Color
    
    getColorClick.RGBAssign 215, 215, 215

    If VersionMajor <= 12 Then
        MsgBox "Sorry, this macro is only compatibile with CorelDraw version 13 and above. Assigning a default color...", vbCritical, cMACRONAME
        Exit Function
    End If

   getColorClick.UserAssignEx
    
End Function

Private Sub setControlColor(i%, ByVal strControl$)
    Dim t As Control
    Dim col As New Color
    
    For Each t In Me.Controls
        If VBA.InStr(t.Name, strControl) Then
            col.CopyAssign getCol(i)
            col.ConvertToRGB
            t.BackColor = RGB(col.RGBRed, col.RGBGreen, col.RGBBlue)
            Exit Sub
        End If
    Next t
    
End Sub

Private Sub saveCol(ByVal col As Color, i%)
    SaveSetting cMACRONAME, "Pref_" & VersionMajor, "col_" & i, col.ToString
End Sub

Private Function getCol(i%) As Color
    Dim strCol$
    
    Set getCol = New Color
    strCol = GetSetting(cMACRONAME, "Pref_" & VersionMajor, "col_" & i)
    
    If strCol = "" Then
        getCol.RGBAssign 204, 204, 204
    Else
        getCol.StringAssign strCol
    End If
    
End Function

Private Sub UserForm_DblClick(ByVal Cancel As MSForms.ReturnBoolean)
    Dim col As New Color
    Dim i%
    
    i = 3
    col.CopyAssign getColorClick
    saveCol col, i
    col.ConvertToRGB
    Me.BackColor = RGB(col.RGBRed, col.RGBGreen, col.RGBBlue)

End Sub

Private Sub UserForm_Initialize()
    Dim col As New Color
     setControlColor 1, "cmdCol"
     setControlColor 2, "cmdCol2"
     
    col.CopyAssign getCol(3)
    col.ConvertToRGB
    Me.BackColor = RGB(col.RGBRed, col.RGBGreen, col.RGBBlue)
     
End Sub
